package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10018ActivateBean;
import cn.net.cpzslibs.prot.handset.bean.Prot10018SendBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10018activate extends ProtBase {
	private final short iTaskCode10018 = 10018;

	private Gson gson;

	private Prot10018ActivateBean resBean;

	public Prot10018activate() {
		gson = new Gson();
	}
	
	public Prot10018ActivateBean getResBean() {
		return resBean;
	}




	public void setResBean(Prot10018ActivateBean resBean) {
		this.resBean = resBean;
	}




	public void dealLabelList(SocketCreate create, Prot10018SendBean labelBean)
			throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), labelBean);
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10018SendBean labelBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10018, "开始请求产品列表");
				sendProt(dos, labelBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recJson(dis);
			}
		}
	}

	/**
	 * 发送JSon数据到服务器
	 */
	private void sendProt(DataOutputStream dos, Prot10018SendBean labelBean)
			throws IOException {
		String bodyContent = gson.toJson(labelBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10018, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));

		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recJson(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10018, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10018, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, Prot10018ActivateBean.class);
		}
		recCheckCode(dis);
	}

}
